import{s as ma,n as la,o as pa}from"../chunks/scheduler.7b8d42e8.js";import{S as ga,i as ca,g as i,s as n,r as p,A as ha,h as s,f as e,c as o,j as Q,u as g,x as z,k as Z,y as aa,a as r,v as c,d as h,t as d,w as _}from"../chunks/index.0671836c.js";import{D as da}from"../chunks/Docstring.8421363b.js";import{H as N,E as _a}from"../chunks/EditOnGithub.15b2d305.js";function ua(ta){let m,F,C,j,u,S,b,ea=`DreamBooth is an innovative method that allows for the customization of text-to-image
models like Stable Diffusion using just a few images of a subject.
DreamBooth enables the generation of new, contextually varied images of the
subject in a range of scenes, poses, and viewpoints, expanding the creative
possibilities of generative models.`,A,f,M,v,ra="The data format for DreamBooth training is simple. All you need is images of a concept (e.g. a person) and a concept token.",Y,x,L,P,na=`Collect 3-5 high-quality images of the subject you wish to personalize.
These images should vary slightly in pose or background to provide the model with a
diverse learning set. You can select more images if you want to train a more robust model.`,q,T,H,D,oa=`Choose a base model from the Hugging Face Hub that is compatible with your needs.
It’s essential to select a model that supports the image size of your training data.
Models available on the hub often have specific requirements or capabilities,
so ensure the model you choose can accommodate the dimensions of your images.`,I,B,R,k,ia=`The concept token is a crucial element in DreamBooth training.
This token acts as a unique identifier for your subject within the model.
Typically, you will use a simple, descriptive keyword like prompt in the parameters
section of your training setup. This token will be used to generate new images of
your subject by the model.`,G,$,U,l,w,K,O,sa="DreamBoothTrainingParams",V,y,W,E,X;return u=new N({props:{title:"DreamBooth",local:"dreambooth",headingTag:"h1"}}),f=new N({props:{title:"Data Preparation",local:"data-preparation",headingTag:"h2"}}),x=new N({props:{title:"Step 1: Gather Your Images",local:"step-1-gather-your-images",headingTag:"h3"}}),T=new N({props:{title:"Step 2: Select Your Model",local:"step-2-select-your-model",headingTag:"h3"}}),B=new N({props:{title:"Step 3: Define Your Concept Token",local:"step-3-define-your-concept-token",headingTag:"h3"}}),$=new N({props:{title:"Parameters",local:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams",headingTag:"h2"}}),w=new da({props:{name:"class autotrain.trainers.dreambooth.params.DreamBoothTrainingParams",anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams",parameters:[{name:"model",val:": str = None"},{name:"vae_model",val:": Optional = None"},{name:"revision",val:": Optional = None"},{name:"tokenizer",val:": Optional = None"},{name:"image_path",val:": str = None"},{name:"class_image_path",val:": Optional = None"},{name:"prompt",val:": str = None"},{name:"class_prompt",val:": Optional = None"},{name:"num_class_images",val:": int = 100"},{name:"class_labels_conditioning",val:": Optional = None"},{name:"prior_preservation",val:": bool = False"},{name:"prior_loss_weight",val:": float = 1.0"},{name:"project_name",val:": str = 'dreambooth-model'"},{name:"seed",val:": int = 42"},{name:"resolution",val:": int = 512"},{name:"center_crop",val:": bool = False"},{name:"train_text_encoder",val:": bool = False"},{name:"batch_size",val:": int = 4"},{name:"sample_batch_size",val:": int = 4"},{name:"epochs",val:": int = 1"},{name:"num_steps",val:": int = None"},{name:"checkpointing_steps",val:": int = 500"},{name:"resume_from_checkpoint",val:": Optional = None"},{name:"gradient_accumulation",val:": int = 1"},{name:"disable_gradient_checkpointing",val:": bool = False"},{name:"lr",val:": float = 0.0001"},{name:"scale_lr",val:": bool = False"},{name:"scheduler",val:": str = 'constant'"},{name:"warmup_steps",val:": int = 0"},{name:"num_cycles",val:": int = 1"},{name:"lr_power",val:": float = 1.0"},{name:"dataloader_num_workers",val:": int = 0"},{name:"use_8bit_adam",val:": bool = False"},{name:"adam_beta1",val:": float = 0.9"},{name:"adam_beta2",val:": float = 0.999"},{name:"adam_weight_decay",val:": float = 0.01"},{name:"adam_epsilon",val:": float = 1e-08"},{name:"max_grad_norm",val:": float = 1.0"},{name:"allow_tf32",val:": bool = False"},{name:"prior_generation_precision",val:": Optional = None"},{name:"local_rank",val:": int = -1"},{name:"xformers",val:": bool = False"},{name:"pre_compute_text_embeddings",val:": bool = False"},{name:"tokenizer_max_length",val:": Optional = None"},{name:"text_encoder_use_attention_mask",val:": bool = False"},{name:"rank",val:": int = 4"},{name:"xl",val:": bool = False"},{name:"mixed_precision",val:": Optional = None"},{name:"token",val:": Optional = None"},{name:"push_to_hub",val:": bool = False"},{name:"username",val:": Optional = None"},{name:"validation_prompt",val:": Optional = None"},{name:"num_validation_images",val:": int = 4"},{name:"validation_epochs",val:": int = 50"},{name:"checkpoints_total_limit",val:": Optional = None"},{name:"validation_images",val:": Optional = None"},{name:"logging",val:": bool = False"}],parametersDescription:[{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.model",description:"<strong>model</strong> (str) &#x2014; Name of the model to be used for training.",name:"model"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.vae_model",description:"<strong>vae_model</strong> (Optional[str]) &#x2014; Name of the VAE model to be used, if any.",name:"vae_model"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.revision",description:"<strong>revision</strong> (Optional[str]) &#x2014; Specific model version to use.",name:"revision"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.tokenizer",description:"<strong>tokenizer</strong> (Optional[str]) &#x2014; Tokenizer to be used, if different from the model.",name:"tokenizer"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.image_path",description:"<strong>image_path</strong> (str) &#x2014; Path to the training images.",name:"image_path"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.class_image_path",description:"<strong>class_image_path</strong> (Optional[str]) &#x2014; Path to the class images.",name:"class_image_path"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.prompt",description:"<strong>prompt</strong> (str) &#x2014; Prompt for the instance images.",name:"prompt"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.class_prompt",description:"<strong>class_prompt</strong> (Optional[str]) &#x2014; Prompt for the class images.",name:"class_prompt"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.num_class_images",description:"<strong>num_class_images</strong> (int) &#x2014; Number of class images to generate.",name:"num_class_images"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.class_labels_conditioning",description:"<strong>class_labels_conditioning</strong> (Optional[str]) &#x2014; Conditioning labels for class images.",name:"class_labels_conditioning"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.prior_preservation",description:"<strong>prior_preservation</strong> (bool) &#x2014; Enable prior preservation during training.",name:"prior_preservation"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.prior_loss_weight",description:"<strong>prior_loss_weight</strong> (float) &#x2014; Weight of the prior preservation loss.",name:"prior_loss_weight"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.project_name",description:"<strong>project_name</strong> (str) &#x2014; Name of the project for output directory.",name:"project_name"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.seed",description:"<strong>seed</strong> (int) &#x2014; Random seed for reproducibility.",name:"seed"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.resolution",description:"<strong>resolution</strong> (int) &#x2014; Resolution of the training images.",name:"resolution"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.center_crop",description:"<strong>center_crop</strong> (bool) &#x2014; Enable center cropping of images.",name:"center_crop"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.train_text_encoder",description:"<strong>train_text_encoder</strong> (bool) &#x2014; Enable training of the text encoder.",name:"train_text_encoder"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.batch_size",description:"<strong>batch_size</strong> (int) &#x2014; Batch size for training.",name:"batch_size"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.sample_batch_size",description:"<strong>sample_batch_size</strong> (int) &#x2014; Batch size for sampling.",name:"sample_batch_size"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.epochs",description:"<strong>epochs</strong> (int) &#x2014; Number of training epochs.",name:"epochs"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.num_steps",description:"<strong>num_steps</strong> (int) &#x2014; Maximum number of training steps.",name:"num_steps"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.checkpointing_steps",description:"<strong>checkpointing_steps</strong> (int) &#x2014; Steps interval for checkpointing.",name:"checkpointing_steps"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.resume_from_checkpoint",description:"<strong>resume_from_checkpoint</strong> (Optional[str]) &#x2014; Path to resume training from a checkpoint.",name:"resume_from_checkpoint"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.gradient_accumulation",description:"<strong>gradient_accumulation</strong> (int) &#x2014; Number of gradient accumulation steps.",name:"gradient_accumulation"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.disable_gradient_checkpointing",description:"<strong>disable_gradient_checkpointing</strong> (bool) &#x2014; Disable gradient checkpointing.",name:"disable_gradient_checkpointing"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.lr",description:"<strong>lr</strong> (float) &#x2014; Learning rate for training.",name:"lr"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.scale_lr",description:"<strong>scale_lr</strong> (bool) &#x2014; Enable scaling of the learning rate.",name:"scale_lr"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.scheduler",description:"<strong>scheduler</strong> (str) &#x2014; Type of learning rate scheduler.",name:"scheduler"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.warmup_steps",description:"<strong>warmup_steps</strong> (int) &#x2014; Number of warmup steps for learning rate scheduler.",name:"warmup_steps"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.num_cycles",description:"<strong>num_cycles</strong> (int) &#x2014; Number of cycles for learning rate scheduler.",name:"num_cycles"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.lr_power",description:"<strong>lr_power</strong> (float) &#x2014; Power factor for learning rate scheduler.",name:"lr_power"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.dataloader_num_workers",description:"<strong>dataloader_num_workers</strong> (int) &#x2014; Number of workers for data loading.",name:"dataloader_num_workers"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.use_8bit_adam",description:"<strong>use_8bit_adam</strong> (bool) &#x2014; Enable use of 8-bit Adam optimizer.",name:"use_8bit_adam"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.adam_beta1",description:"<strong>adam_beta1</strong> (float) &#x2014; Beta1 parameter for Adam optimizer.",name:"adam_beta1"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.adam_beta2",description:"<strong>adam_beta2</strong> (float) &#x2014; Beta2 parameter for Adam optimizer.",name:"adam_beta2"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.adam_weight_decay",description:"<strong>adam_weight_decay</strong> (float) &#x2014; Weight decay for Adam optimizer.",name:"adam_weight_decay"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.adam_epsilon",description:"<strong>adam_epsilon</strong> (float) &#x2014; Epsilon parameter for Adam optimizer.",name:"adam_epsilon"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.max_grad_norm",description:"<strong>max_grad_norm</strong> (float) &#x2014; Maximum gradient norm for clipping.",name:"max_grad_norm"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.allow_tf32",description:"<strong>allow_tf32</strong> (bool) &#x2014; Allow use of TF32 for training.",name:"allow_tf32"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.prior_generation_precision",description:"<strong>prior_generation_precision</strong> (Optional[str]) &#x2014; Precision for prior generation.",name:"prior_generation_precision"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.local_rank",description:"<strong>local_rank</strong> (int) &#x2014; Local rank for distributed training.",name:"local_rank"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.xformers",description:"<strong>xformers</strong> (bool) &#x2014; Enable xformers memory efficient attention.",name:"xformers"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.pre_compute_text_embeddings",description:"<strong>pre_compute_text_embeddings</strong> (bool) &#x2014; Pre-compute text embeddings before training.",name:"pre_compute_text_embeddings"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.tokenizer_max_length",description:"<strong>tokenizer_max_length</strong> (Optional[int]) &#x2014; Maximum length for tokenizer.",name:"tokenizer_max_length"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.text_encoder_use_attention_mask",description:"<strong>text_encoder_use_attention_mask</strong> (bool) &#x2014; Use attention mask for text encoder.",name:"text_encoder_use_attention_mask"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.rank",description:"<strong>rank</strong> (int) &#x2014; Rank for distributed training.",name:"rank"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.xl",description:"<strong>xl</strong> (bool) &#x2014; Enable XL model training.",name:"xl"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.mixed_precision",description:"<strong>mixed_precision</strong> (Optional[str]) &#x2014; Enable mixed precision training.",name:"mixed_precision"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.token",description:"<strong>token</strong> (Optional[str]) &#x2014; Token for accessing the model hub.",name:"token"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.push_to_hub",description:"<strong>push_to_hub</strong> (bool) &#x2014; Enable pushing the model to the hub.",name:"push_to_hub"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.username",description:"<strong>username</strong> (Optional[str]) &#x2014; Username for the model hub.",name:"username"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.validation_prompt",description:"<strong>validation_prompt</strong> (Optional[str]) &#x2014; Prompt for validation images.",name:"validation_prompt"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.num_validation_images",description:"<strong>num_validation_images</strong> (int) &#x2014; Number of validation images to generate.",name:"num_validation_images"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.validation_epochs",description:"<strong>validation_epochs</strong> (int) &#x2014; Epoch interval for validation.",name:"validation_epochs"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.checkpoints_total_limit",description:"<strong>checkpoints_total_limit</strong> (Optional[int]) &#x2014; Total limit for checkpoints.",name:"checkpoints_total_limit"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.validation_images",description:"<strong>validation_images</strong> (Optional[str]) &#x2014; Path to validation images.",name:"validation_images"},{anchor:"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams.logging",description:"<strong>logging</strong> (bool) &#x2014; Enable logging using TensorBoard.",name:"logging"}],source:"https://github.com/huggingface/autotrain-advanced/blob/main/src/autotrain/trainers/dreambooth/params.py#L8"}}),y=new _a({props:{source:"https://github.com/huggingface/autotrain-advanced/blob/main/docs/source/tasks/dreambooth.mdx"}}),{c(){m=i("meta"),F=n(),C=i("p"),j=n(),p(u.$$.fragment),S=n(),b=i("p"),b.textContent=ea,A=n(),p(f.$$.fragment),M=n(),v=i("p"),v.textContent=ra,Y=n(),p(x.$$.fragment),L=n(),P=i("p"),P.textContent=na,q=n(),p(T.$$.fragment),H=n(),D=i("p"),D.textContent=oa,I=n(),p(B.$$.fragment),R=n(),k=i("p"),k.textContent=ia,G=n(),p($.$$.fragment),U=n(),l=i("div"),p(w.$$.fragment),K=n(),O=i("p"),O.textContent=sa,V=n(),p(y.$$.fragment),W=n(),E=i("p"),this.h()},l(a){const t=ha("svelte-u9bgzb",document.head);m=s(t,"META",{name:!0,content:!0}),t.forEach(e),F=o(a),C=s(a,"P",{}),Q(C).forEach(e),j=o(a),g(u.$$.fragment,a),S=o(a),b=s(a,"P",{"data-svelte-h":!0}),z(b)!=="svelte-1yr0pw0"&&(b.textContent=ea),A=o(a),g(f.$$.fragment,a),M=o(a),v=s(a,"P",{"data-svelte-h":!0}),z(v)!=="svelte-rjhwly"&&(v.textContent=ra),Y=o(a),g(x.$$.fragment,a),L=o(a),P=s(a,"P",{"data-svelte-h":!0}),z(P)!=="svelte-csnd71"&&(P.textContent=na),q=o(a),g(T.$$.fragment,a),H=o(a),D=s(a,"P",{"data-svelte-h":!0}),z(D)!=="svelte-jrfyfp"&&(D.textContent=oa),I=o(a),g(B.$$.fragment,a),R=o(a),k=s(a,"P",{"data-svelte-h":!0}),z(k)!=="svelte-5dif2c"&&(k.textContent=ia),G=o(a),g($.$$.fragment,a),U=o(a),l=s(a,"DIV",{class:!0});var J=Q(l);g(w.$$.fragment,J),K=o(J),O=s(J,"P",{"data-svelte-h":!0}),z(O)!=="svelte-pvs197"&&(O.textContent=sa),J.forEach(e),V=o(a),g(y.$$.fragment,a),W=o(a),E=s(a,"P",{}),Q(E).forEach(e),this.h()},h(){Z(m,"name","hf:doc:metadata"),Z(m,"content",ba),Z(l,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(a,t){aa(document.head,m),r(a,F,t),r(a,C,t),r(a,j,t),c(u,a,t),r(a,S,t),r(a,b,t),r(a,A,t),c(f,a,t),r(a,M,t),r(a,v,t),r(a,Y,t),c(x,a,t),r(a,L,t),r(a,P,t),r(a,q,t),c(T,a,t),r(a,H,t),r(a,D,t),r(a,I,t),c(B,a,t),r(a,R,t),r(a,k,t),r(a,G,t),c($,a,t),r(a,U,t),r(a,l,t),c(w,l,null),aa(l,K),aa(l,O),r(a,V,t),c(y,a,t),r(a,W,t),r(a,E,t),X=!0},p:la,i(a){X||(h(u.$$.fragment,a),h(f.$$.fragment,a),h(x.$$.fragment,a),h(T.$$.fragment,a),h(B.$$.fragment,a),h($.$$.fragment,a),h(w.$$.fragment,a),h(y.$$.fragment,a),X=!0)},o(a){d(u.$$.fragment,a),d(f.$$.fragment,a),d(x.$$.fragment,a),d(T.$$.fragment,a),d(B.$$.fragment,a),d($.$$.fragment,a),d(w.$$.fragment,a),d(y.$$.fragment,a),X=!1},d(a){a&&(e(F),e(C),e(j),e(S),e(b),e(A),e(M),e(v),e(Y),e(L),e(P),e(q),e(H),e(D),e(I),e(R),e(k),e(G),e(U),e(l),e(V),e(W),e(E)),e(m),_(u,a),_(f,a),_(x,a),_(T,a),_(B,a),_($,a),_(w),_(y,a)}}}const ba='{"title":"DreamBooth","local":"dreambooth","sections":[{"title":"Data Preparation","local":"data-preparation","sections":[{"title":"Step 1: Gather Your Images","local":"step-1-gather-your-images","sections":[],"depth":3},{"title":"Step 2: Select Your Model","local":"step-2-select-your-model","sections":[],"depth":3},{"title":"Step 3: Define Your Concept Token","local":"step-3-define-your-concept-token","sections":[],"depth":3}],"depth":2},{"title":"Parameters","local":"autotrain.trainers.dreambooth.params.DreamBoothTrainingParams","sections":[],"depth":2}],"depth":1}';function fa(ta){return pa(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Da extends ga{constructor(m){super(),ca(this,m,fa,ua,ma,{})}}export{Da as component};
